Page MenuHomePhabricator

[Wikimedia Commons app] Allow users to browse Commons from app
Closed, ResolvedPublic

Description

The Wikimedia Commons Android app allows users to upload pictures from their Android phone/tablet to Wikimedia Commons. GitHub page is here.

Project
The Wikimedia Commons App is to currently focused on upload. More and more, users are asking (as evidenced by Play Store feedback), people want to be able to also browse existing Commons images via the app. By letting users see other people's work, we believe the quality of uploads will increase.
Project schedule :

  1. Get familiar with the scrolling list of recently featured images, test it and fix any bug
  2. Add search button
  3. Use the Mediawiki API to make the search button list results
  4. Restrict the search results to images, or make sure no crash happen when opening exotic formats such as SVGs or sounds
  5. Release (at least in alpha), write documentation, test, fix bugs
  6. Modify the search button to also search for categories
  7. In the same results list, also show categories
  8. Implement the category activity, which shows the sub-categories and the images present in that category
  9. Release (at least in alpha), write documentation, test, fix bugs
  10. Bonus if time allows: modify the category activity to show the best images first. Ideally it should be recursive, so that the activity for Category:Butterflies shows good images in subcategories (images that have not been moved to a sub-category are usually not great images). To do that we could possibly query FastCCI if we can find a way to make it work reliably.

Here is the related discussion on GitHub.

Skills required

  • Android SDK
  • Android UI design
  • Understanding of RxJava
  • Basic knowledge of Wikimedia APIs

Nice to have skills

  • Familiarity with Kotlin

Mentors
Mentor: @Nes
Co-mentor: @Nicolas_Raoul

Get started

Event Timeline

Nes created this task.Mar 4 2018, 9:14 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 4 2018, 9:14 PM
Nes updated the task description. (Show Details)Mar 5 2018, 11:48 AM
josephine_l added a subscriber: josephine_l.
Nicolas_Raoul updated the task description. (Show Details)Mar 6 2018, 5:02 AM
Nicolas_Raoul awarded a token.

This message is for students interested in working on this project for Google-Summer-of-Code (2018)

  • Student application deadline is March 27 16:00 UTC.
  • If you have questions about eligibility, please read the GSoC rules thoroughly here https://summerofcode.withgoogle.com/rules/. Wikimedia will not be responsible for verifying your eligibility and also not be able to make any decisions on this. For any clarifying questions, please email gsoc-support@google.com
  • Ensure that by now you have already discussed your implementation approach with your mentors, completed a few bugs/microtasks and made a plan to move forward with the proposal
  • I encourage you to start creating your proposals on Phabricator now to receive timely feedback on them from mentors. Do not wait until the last minute. Give your mentors at least a week's time to review your proposal, so that you could then incorporate any suggestions for changes. Learn how to submit a proposal in our participant's guide: https://www.mediawiki.org/wiki/Google_Summer_of_Code/Participants (Step 9)
  • Proposals that contain links to successfully merged patches before the application period and submitted on both Phabricator and GSoC portal will only be considered for the review process. So, between now and the application deadline, you could consider working on this task.
  • If you would like to chat with me more about the process or have questions, come and talk to me in the Zulip chat: https://wikimedia.zulipchat.com/

I think we can try to expand the scope of the project a bit and allow users who aren't logged in to browse Commons and upload images as well. It won't require a very drastic refactoring of the application, since MediaWiki and the APIs support anonymous edits (in a manner of speaking, it attributes it to the IP address of the user, instead).
However, the ContributionsActivity would have to go (for a user who isn't logged in, that is) , since the IP of a mobile user will keep changing.
GitHub issue #1221 talks about this too, though the implementation for the fix described there is quite different.

Just to clarify can anyone help me what does this statement mean:
"In the same results list, also show categories" 7th point in project schedule.
Does it mean showing all the categories with the obtained result in featured images after searching.
Please correct me if I'm wrong. Thanks:)

@Diddypod I don't think anonymous users can upload pictures?

@Jatin0312 Try searching for "ankake udon" on Commons: You get a mix of files and categories https://commons.wikimedia.org/w/index.php?title=Special:Search&search=ankake+udon&fulltext=Search

Diddypod added a comment.EditedMar 21 2018, 5:23 AM

@Nicolas_Raoul you're correct. Users who aren't logged in can edit pages, but not upload images. I'm sorry for the mistake.

Ros65536 removed a subscriber: Ros65536.
Ros65536 added a subscriber: Ros65536.

ping @Nicolas_Raoul @Nes @Ujjwalagrawal17 Is there anything remaining in this task from GSoC'18? If not, then please consider marking it as resolved! Ensure no pull requests are remaining to be merged and deployed in production and documentation both on-wiki and in the code is complete. If yes, then you could move the leftovers to a new task.

Nicolas_Raoul closed this task as Resolved.Sep 13 2018, 3:25 AM
Nicolas_Raoul claimed this task.